diff -urNp linux-2.6.32.24/drivers/oprofile/oprofile_stats.h linux-2.6.32.24/drivers/oprofile/oprofile_stats.h
--- linux-2.6.32.24/drivers/oprofile/oprofile_stats.h	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/oprofile/oprofile_stats.h	2010-09-04 15:54:52.000000000 -0400
@@ -13,11 +13,11 @@
 #include <asm/atomic.h>
 
 struct oprofile_stat_struct {
-	atomic_t sample_lost_no_mm;
-	atomic_t sample_lost_no_mapping;
-	atomic_t bt_lost_no_mapping;
-	atomic_t event_lost_overflow;
-	atomic_t multiplex_counter;
+	atomic_unchecked_t sample_lost_no_mm;
+	atomic_unchecked_t sample_lost_no_mapping;
+	atomic_unchecked_t bt_lost_no_mapping;
+	atomic_unchecked_t event_lost_overflow;
+	atomic_unchecked_t multiplex_counter;
 };
 
 extern struct oprofile_stat_struct oprofile_stats;
diff -urNp linux-2.6.32.24/drivers/parisc/pdc_stable.c linux-2.6.32.24/drivers/parisc/pdc_stable.c
--- linux-2.6.32.24/drivers/parisc/pdc_stable.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/parisc/pdc_stable.c	2010-09-04 15:54:52.000000000 -0400
@@ -481,7 +481,7 @@ pdcspath_attr_store(struct kobject *kobj
 	return ret;
 }
 
-static struct sysfs_ops pdcspath_attr_ops = {
+static const struct sysfs_ops pdcspath_attr_ops = {
 	.show = pdcspath_attr_show,
 	.store = pdcspath_attr_store,
 };
diff -urNp linux-2.6.32.24/drivers/parport/procfs.c linux-2.6.32.24/drivers/parport/procfs.c
--- linux-2.6.32.24/drivers/parport/procfs.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/parport/procfs.c	2010-09-04 15:54:52.000000000 -0400
@@ -64,7 +64,7 @@ static int do_active_device(ctl_table *t
 
 	*ppos += len;
 
-	return copy_to_user(result, buffer, len) ? -EFAULT : 0;
+	return (len > sizeof buffer || copy_to_user(result, buffer, len)) ? -EFAULT : 0;
 }
 
 #ifdef CONFIG_PARPORT_1284
@@ -106,7 +106,7 @@ static int do_autoprobe(ctl_table *table
 
 	*ppos += len;
 
-	return copy_to_user (result, buffer, len) ? -EFAULT : 0;
+	return (len > sizeof buffer || copy_to_user (result, buffer, len)) ? -EFAULT : 0;
 }
 #endif /* IEEE1284.3 support. */
 
diff -urNp linux-2.6.32.24/drivers/pci/hotplug/acpiphp_glue.c linux-2.6.32.24/drivers/pci/hotplug/acpiphp_glue.c
--- linux-2.6.32.24/drivers/pci/hotplug/acpiphp_glue.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/pci/hotplug/acpiphp_glue.c	2010-09-04 15:54:52.000000000 -0400
@@ -111,7 +111,7 @@ static int post_dock_fixups(struct notif
 }
 
 
-static struct acpi_dock_ops acpiphp_dock_ops = {
+static const struct acpi_dock_ops acpiphp_dock_ops = {
 	.handler = handle_hotplug_event_func,
 };
 
diff -urNp linux-2.6.32.24/drivers/pci/hotplug/cpqphp_nvram.c linux-2.6.32.24/drivers/pci/hotplug/cpqphp_nvram.c
--- linux-2.6.32.24/drivers/pci/hotplug/cpqphp_nvram.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/pci/hotplug/cpqphp_nvram.c	2010-09-04 15:54:52.000000000 -0400
@@ -428,9 +428,13 @@ static u32 store_HRT (void __iomem *rom_
 
 void compaq_nvram_init (void __iomem *rom_start)
 {
+
+#ifndef CONFIG_PAX_KERNEXEC
 	if (rom_start) {
 		compaq_int15_entry_point = (rom_start + ROM_INT15_PHY_ADDR - ROM_PHY_ADDR);
 	}
+#endif
+
 	dbg("int15 entry  = %p\n", compaq_int15_entry_point);
 
 	/* initialize our int15 lock */
diff -urNp linux-2.6.32.24/drivers/pci/hotplug/fakephp.c linux-2.6.32.24/drivers/pci/hotplug/fakephp.c
--- linux-2.6.32.24/drivers/pci/hotplug/fakephp.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/pci/hotplug/fakephp.c	2010-09-04 15:54:52.000000000 -0400
@@ -73,7 +73,7 @@ static void legacy_release(struct kobjec
 }
 
 static struct kobj_type legacy_ktype = {
-	.sysfs_ops = &(struct sysfs_ops){
+	.sysfs_ops = &(const struct sysfs_ops){
 		.store = legacy_store, .show = legacy_show
 	},
 	.release = &legacy_release,
diff -urNp linux-2.6.32.24/drivers/pci/intel-iommu.c linux-2.6.32.24/drivers/pci/intel-iommu.c
--- linux-2.6.32.24/drivers/pci/intel-iommu.c	2010-09-26 17:26:05.000000000 -0400
+++ linux-2.6.32.24/drivers/pci/intel-iommu.c	2010-09-26 17:26:38.000000000 -0400
@@ -2643,7 +2643,7 @@ error:
 	return 0;
 }
 
-static dma_addr_t intel_map_page(struct device *dev, struct page *page,
+dma_addr_t intel_map_page(struct device *dev, struct page *page,
 				 unsigned long offset, size_t size,
 				 enum dma_data_direction dir,
 				 struct dma_attrs *attrs)
@@ -2719,7 +2719,7 @@ static void add_unmap(struct dmar_domain
 	spin_unlock_irqrestore(&async_umap_flush_lock, flags);
 }
 
-static void intel_unmap_page(struct device *dev, dma_addr_t dev_addr,
+void intel_unmap_page(struct device *dev, dma_addr_t dev_addr,
 			     size_t size, enum dma_data_direction dir,
 			     struct dma_attrs *attrs)
 {
@@ -2768,7 +2768,7 @@ static void intel_unmap_page(struct devi
 	}
 }
 
-static void *intel_alloc_coherent(struct device *hwdev, size_t size,
+void *intel_alloc_coherent(struct device *hwdev, size_t size,
 				  dma_addr_t *dma_handle, gfp_t flags)
 {
 	void *vaddr;
@@ -2800,7 +2800,7 @@ static void *intel_alloc_coherent(struct
 	return NULL;
 }
 
-static void intel_free_coherent(struct device *hwdev, size_t size, void *vaddr,
+void intel_free_coherent(struct device *hwdev, size_t size, void *vaddr,
 				dma_addr_t dma_handle)
 {
 	int order;
@@ -2812,7 +2812,7 @@ static void intel_free_coherent(struct d
 	free_pages((unsigned long)vaddr, order);
 }
 
-static void intel_unmap_sg(struct device *hwdev, struct scatterlist *sglist,
+void intel_unmap_sg(struct device *hwdev, struct scatterlist *sglist,
 			   int nelems, enum dma_data_direction dir,
 			   struct dma_attrs *attrs)
 {
@@ -2872,7 +2872,7 @@ static int intel_nontranslate_map_sg(str
 	return nelems;
 }
 
-static int intel_map_sg(struct device *hwdev, struct scatterlist *sglist, int nelems,
+int intel_map_sg(struct device *hwdev, struct scatterlist *sglist, int nelems,
 			enum dma_data_direction dir, struct dma_attrs *attrs)
 {
 	int i;
@@ -2941,12 +2941,12 @@ static int intel_map_sg(struct device *h
 	return nelems;
 }
 
-static int intel_mapping_error(struct device *dev, dma_addr_t dma_addr)
+int intel_mapping_error(struct device *dev, dma_addr_t dma_addr)
 {
 	return !dma_addr;
 }
 
-struct dma_map_ops intel_dma_ops = {
+const struct dma_map_ops intel_dma_ops = {
 	.alloc_coherent = intel_alloc_coherent,
 	.free_coherent = intel_free_coherent,
 	.map_sg = intel_map_sg,
diff -urNp linux-2.6.32.24/drivers/pci/pcie/portdrv_pci.c linux-2.6.32.24/drivers/pci/pcie/portdrv_pci.c
--- linux-2.6.32.24/drivers/pci/pcie/portdrv_pci.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/pci/pcie/portdrv_pci.c	2010-09-04 15:54:52.000000000 -0400
@@ -249,7 +249,7 @@ static void pcie_portdrv_err_resume(stru
 static const struct pci_device_id port_pci_ids[] = { {
 	/* handle any PCI-Express port */
 	PCI_DEVICE_CLASS(((PCI_CLASS_BRIDGE_PCI << 8) | 0x00), ~0),
-	}, { /* end: all zeroes */ }
+	}, { 0, 0, 0, 0, 0, 0, 0 }
 };
 MODULE_DEVICE_TABLE(pci, port_pci_ids);
 
diff -urNp linux-2.6.32.24/drivers/pci/probe.c linux-2.6.32.24/drivers/pci/probe.c
--- linux-2.6.32.24/drivers/pci/probe.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/pci/probe.c	2010-09-04 15:54:52.000000000 -0400
@@ -62,14 +62,14 @@ static ssize_t pci_bus_show_cpuaffinity(
 	return ret;
 }
 
-static ssize_t inline pci_bus_show_cpumaskaffinity(struct device *dev,
+static inline ssize_t pci_bus_show_cpumaskaffinity(struct device *dev,
 					struct device_attribute *attr,
 					char *buf)
 {
 	return pci_bus_show_cpuaffinity(dev, 0, attr, buf);
 }
 
-static ssize_t inline pci_bus_show_cpulistaffinity(struct device *dev,
+static inline ssize_t pci_bus_show_cpulistaffinity(struct device *dev,
 					struct device_attribute *attr,
 					char *buf)
 {
diff -urNp linux-2.6.32.24/drivers/pci/proc.c linux-2.6.32.24/drivers/pci/proc.c
--- linux-2.6.32.24/drivers/pci/proc.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/pci/proc.c	2010-09-04 15:54:52.000000000 -0400
@@ -480,7 +480,16 @@ static const struct file_operations proc
 static int __init pci_proc_init(void)
 {
 	struct pci_dev *dev = NULL;
+
+#ifdef CONFIG_GRKERNSEC_PROC_ADD
+#ifdef CONFIG_GRKERNSEC_PROC_USER
+	proc_bus_pci_dir = proc_mkdir_mode("bus/pci", S_IRUSR | S_IXUSR, NULL);
+#elif defined(CONFIG_GRKERNSEC_PROC_USERGROUP)
+	proc_bus_pci_dir = proc_mkdir_mode("bus/pci", S_IRUSR | S_IXUSR | S_IRGRP | S_IXGRP, NULL);
+#endif
+#else
 	proc_bus_pci_dir = proc_mkdir("bus/pci", NULL);
+#endif
 	proc_create("devices", 0, proc_bus_pci_dir,
 		    &proc_bus_pci_dev_operations);
 	proc_initialized = 1;
diff -urNp linux-2.6.32.24/drivers/pci/slot.c linux-2.6.32.24/drivers/pci/slot.c
--- linux-2.6.32.24/drivers/pci/slot.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/pci/slot.c	2010-09-04 15:54:52.000000000 -0400
@@ -29,7 +29,7 @@ static ssize_t pci_slot_attr_store(struc
 	return attribute->store ? attribute->store(slot, buf, len) : -EIO;
 }
 
-static struct sysfs_ops pci_slot_sysfs_ops = {
+static const struct sysfs_ops pci_slot_sysfs_ops = {
 	.show = pci_slot_attr_show,
 	.store = pci_slot_attr_store,
 };
diff -urNp linux-2.6.32.24/drivers/pcmcia/pcmcia_ioctl.c linux-2.6.32.24/drivers/pcmcia/pcmcia_ioctl.c
--- linux-2.6.32.24/drivers/pcmcia/pcmcia_ioctl.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/pcmcia/pcmcia_ioctl.c	2010-09-04 15:54:52.000000000 -0400
@@ -819,7 +819,7 @@ static int ds_ioctl(struct inode * inode
 	    return -EFAULT;
 	}
     }
-    buf = kmalloc(sizeof(ds_ioctl_arg_t), GFP_KERNEL);
+    buf = kzalloc(sizeof(ds_ioctl_arg_t), GFP_KERNEL);
     if (!buf)
 	return -ENOMEM;
 
diff -urNp linux-2.6.32.24/drivers/pcmcia/ti113x.h linux-2.6.32.24/drivers/pcmcia/ti113x.h
--- linux-2.6.32.24/drivers/pcmcia/ti113x.h	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/pcmcia/ti113x.h	2010-09-04 15:54:52.000000000 -0400
@@ -903,7 +903,7 @@ static struct pci_device_id ene_tune_tbl
 	DEVID(PCI_VENDOR_ID_MOTOROLA, 0x3410, 0xECC0, PCI_ANY_ID,
 		ENE_TEST_C9_TLTENABLE | ENE_TEST_C9_PFENABLE, ENE_TEST_C9_TLTENABLE),
 
-	{}
+	{ 0, 0, 0, 0, 0, 0, 0 }
 };
 
 static void ene_tune_bridge(struct pcmcia_socket *sock, struct pci_bus *bus)
diff -urNp linux-2.6.32.24/drivers/pcmcia/yenta_socket.c linux-2.6.32.24/drivers/pcmcia/yenta_socket.c
--- linux-2.6.32.24/drivers/pcmcia/yenta_socket.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/pcmcia/yenta_socket.c	2010-09-04 15:54:52.000000000 -0400
@@ -1387,7 +1387,7 @@ static struct pci_device_id yenta_table 
 
 	/* match any cardbus bridge */
 	CB_ID(PCI_ANY_ID, PCI_ANY_ID, DEFAULT),
-	{ /* all zeroes */ }
+	{ 0, 0, 0, 0, 0, 0, 0 }
 };
 MODULE_DEVICE_TABLE(pci, yenta_table);
 
diff -urNp linux-2.6.32.24/drivers/platform/x86/acer-wmi.c linux-2.6.32.24/drivers/platform/x86/acer-wmi.c
--- linux-2.6.32.24/drivers/platform/x86/acer-wmi.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/platform/x86/acer-wmi.c	2010-09-04 15:54:52.000000000 -0400
@@ -918,7 +918,7 @@ static int update_bl_status(struct backl
 	return 0;
 }
 
-static struct backlight_ops acer_bl_ops = {
+static const struct backlight_ops acer_bl_ops = {
 	.get_brightness = read_brightness,
 	.update_status = update_bl_status,
 };
diff -urNp linux-2.6.32.24/drivers/platform/x86/asus_acpi.c linux-2.6.32.24/drivers/platform/x86/asus_acpi.c
--- linux-2.6.32.24/drivers/platform/x86/asus_acpi.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/platform/x86/asus_acpi.c	2010-09-04 15:54:52.000000000 -0400
@@ -1402,7 +1402,7 @@ static int asus_hotk_remove(struct acpi_
 	return 0;
 }
 
-static struct backlight_ops asus_backlight_data = {
+static const struct backlight_ops asus_backlight_data = {
 	.get_brightness = read_brightness,
 	.update_status  = set_brightness_status,
 };
diff -urNp linux-2.6.32.24/drivers/platform/x86/asus-laptop.c linux-2.6.32.24/drivers/platform/x86/asus-laptop.c
--- linux-2.6.32.24/drivers/platform/x86/asus-laptop.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/platform/x86/asus-laptop.c	2010-09-04 15:54:52.000000000 -0400
@@ -250,7 +250,7 @@ static struct backlight_device *asus_bac
  */
 static int read_brightness(struct backlight_device *bd);
 static int update_bl_status(struct backlight_device *bd);
-static struct backlight_ops asusbl_ops = {
+static const struct backlight_ops asusbl_ops = {
 	.get_brightness = read_brightness,
 	.update_status = update_bl_status,
 };
diff -urNp linux-2.6.32.24/drivers/platform/x86/compal-laptop.c linux-2.6.32.24/drivers/platform/x86/compal-laptop.c
--- linux-2.6.32.24/drivers/platform/x86/compal-laptop.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/platform/x86/compal-laptop.c	2010-09-04 15:54:52.000000000 -0400
@@ -163,7 +163,7 @@ static int bl_update_status(struct backl
 	return set_lcd_level(b->props.brightness);
 }
 
-static struct backlight_ops compalbl_ops = {
+static const struct backlight_ops compalbl_ops = {
 	.get_brightness = bl_get_brightness,
 	.update_status	= bl_update_status,
 };
diff -urNp linux-2.6.32.24/drivers/platform/x86/dell-laptop.c linux-2.6.32.24/drivers/platform/x86/dell-laptop.c
--- linux-2.6.32.24/drivers/platform/x86/dell-laptop.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/platform/x86/dell-laptop.c	2010-09-04 15:54:52.000000000 -0400
@@ -305,7 +305,7 @@ static int dell_get_intensity(struct bac
 	return buffer.output[1];
 }
 
-static struct backlight_ops dell_ops = {
+static const struct backlight_ops dell_ops = {
 	.get_brightness = dell_get_intensity,
 	.update_status  = dell_send_intensity,
 };
diff -urNp linux-2.6.32.24/drivers/platform/x86/eeepc-laptop.c linux-2.6.32.24/drivers/platform/x86/eeepc-laptop.c
--- linux-2.6.32.24/drivers/platform/x86/eeepc-laptop.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/platform/x86/eeepc-laptop.c	2010-09-04 15:54:52.000000000 -0400
@@ -245,7 +245,7 @@ static struct device *eeepc_hwmon_device
  */
 static int read_brightness(struct backlight_device *bd);
 static int update_bl_status(struct backlight_device *bd);
-static struct backlight_ops eeepcbl_ops = {
+static const struct backlight_ops eeepcbl_ops = {
 	.get_brightness = read_brightness,
 	.update_status = update_bl_status,
 };
diff -urNp linux-2.6.32.24/drivers/platform/x86/fujitsu-laptop.c linux-2.6.32.24/drivers/platform/x86/fujitsu-laptop.c
--- linux-2.6.32.24/drivers/platform/x86/fujitsu-laptop.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/platform/x86/fujitsu-laptop.c	2010-09-04 15:54:52.000000000 -0400
@@ -436,7 +436,7 @@ static int bl_update_status(struct backl
 	return ret;
 }
 
-static struct backlight_ops fujitsubl_ops = {
+static const struct backlight_ops fujitsubl_ops = {
 	.get_brightness = bl_get_brightness,
 	.update_status = bl_update_status,
 };
diff -urNp linux-2.6.32.24/drivers/platform/x86/msi-laptop.c linux-2.6.32.24/drivers/platform/x86/msi-laptop.c
--- linux-2.6.32.24/drivers/platform/x86/msi-laptop.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/platform/x86/msi-laptop.c	2010-09-04 15:54:52.000000000 -0400
@@ -161,7 +161,7 @@ static int bl_update_status(struct backl
 	return set_lcd_level(b->props.brightness);
 }
 
-static struct backlight_ops msibl_ops = {
+static const struct backlight_ops msibl_ops = {
 	.get_brightness = bl_get_brightness,
 	.update_status  = bl_update_status,
 };
diff -urNp linux-2.6.32.24/drivers/platform/x86/panasonic-laptop.c linux-2.6.32.24/drivers/platform/x86/panasonic-laptop.c
--- linux-2.6.32.24/drivers/platform/x86/panasonic-laptop.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/platform/x86/panasonic-laptop.c	2010-09-04 15:54:52.000000000 -0400
@@ -352,7 +352,7 @@ static int bl_set_status(struct backligh
 	return acpi_pcc_write_sset(pcc, SINF_DC_CUR_BRIGHT, bright);
 }
 
-static struct backlight_ops pcc_backlight_ops = {
+static const struct backlight_ops pcc_backlight_ops = {
 	.get_brightness	= bl_get,
 	.update_status	= bl_set_status,
 };
diff -urNp linux-2.6.32.24/drivers/platform/x86/sony-laptop.c linux-2.6.32.24/drivers/platform/x86/sony-laptop.c
--- linux-2.6.32.24/drivers/platform/x86/sony-laptop.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/platform/x86/sony-laptop.c	2010-09-04 15:54:52.000000000 -0400
@@ -850,7 +850,7 @@ static int sony_backlight_get_brightness
 }
 
 static struct backlight_device *sony_backlight_device;
-static struct backlight_ops sony_backlight_ops = {
+static const struct backlight_ops sony_backlight_ops = {
 	.update_status = sony_backlight_update_status,
 	.get_brightness = sony_backlight_get_brightness,
 };
diff -urNp linux-2.6.32.24/drivers/platform/x86/thinkpad_acpi.c linux-2.6.32.24/drivers/platform/x86/thinkpad_acpi.c
--- linux-2.6.32.24/drivers/platform/x86/thinkpad_acpi.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/platform/x86/thinkpad_acpi.c	2010-09-04 15:54:52.000000000 -0400
@@ -6122,7 +6122,7 @@ static void tpacpi_brightness_notify_cha
 			       BACKLIGHT_UPDATE_HOTKEY);
 }
 
-static struct backlight_ops ibm_backlight_data = {
+static const struct backlight_ops ibm_backlight_data = {
 	.get_brightness = brightness_get,
 	.update_status  = brightness_update_status,
 };
diff -urNp linux-2.6.32.24/drivers/platform/x86/toshiba_acpi.c linux-2.6.32.24/drivers/platform/x86/toshiba_acpi.c
--- linux-2.6.32.24/drivers/platform/x86/toshiba_acpi.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/platform/x86/toshiba_acpi.c	2010-09-04 15:54:52.000000000 -0400
@@ -671,7 +671,7 @@ static acpi_status remove_device(void)
 	return AE_OK;
 }
 
-static struct backlight_ops toshiba_backlight_data = {
+static const struct backlight_ops toshiba_backlight_data = {
         .get_brightness = get_lcd,
         .update_status  = set_lcd_status,
 };
diff -urNp linux-2.6.32.24/drivers/pnp/pnpbios/bioscalls.c linux-2.6.32.24/drivers/pnp/pnpbios/bioscalls.c
--- linux-2.6.32.24/drivers/pnp/pnpbios/bioscalls.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/pnp/pnpbios/bioscalls.c	2010-09-04 15:54:52.000000000 -0400
@@ -60,7 +60,7 @@ do { \
 	set_desc_limit(&gdt[(selname) >> 3], (size) - 1); \
 } while(0)
 
-static struct desc_struct bad_bios_desc = GDT_ENTRY_INIT(0x4092,
+static const struct desc_struct bad_bios_desc = GDT_ENTRY_INIT(0x4093,
 			(unsigned long)__va(0x400UL), PAGE_SIZE - 0x400 - 1);
 
 /*
@@ -97,7 +97,10 @@ static inline u16 call_pnp_bios(u16 func
 
 	cpu = get_cpu();
 	save_desc_40 = get_cpu_gdt_table(cpu)[0x40 / 8];
+
+	pax_open_kernel();
 	get_cpu_gdt_table(cpu)[0x40 / 8] = bad_bios_desc;
+	pax_close_kernel();
 
 	/* On some boxes IRQ's during PnP BIOS calls are deadly.  */
 	spin_lock_irqsave(&pnp_bios_lock, flags);
@@ -135,7 +138,10 @@ static inline u16 call_pnp_bios(u16 func
 			     :"memory");
 	spin_unlock_irqrestore(&pnp_bios_lock, flags);
 
+	pax_open_kernel();
 	get_cpu_gdt_table(cpu)[0x40 / 8] = save_desc_40;
+	pax_close_kernel();
+
 	put_cpu();
 
 	/* If we get here and this is set then the PnP BIOS faulted on us. */
@@ -469,7 +475,7 @@ int pnp_bios_read_escd(char *data, u32 n
 	return status;
 }
 
-void pnpbios_calls_init(union pnp_bios_install_struct *header)
+void __init pnpbios_calls_init(union pnp_bios_install_struct *header)
 {
 	int i;
 
@@ -477,6 +483,8 @@ void pnpbios_calls_init(union pnp_bios_i
 	pnp_bios_callpoint.offset = header->fields.pm16offset;
 	pnp_bios_callpoint.segment = PNP_CS16;
 
+	pax_open_kernel();
+
 	for_each_possible_cpu(i) {
 		struct desc_struct *gdt = get_cpu_gdt_table(i);
 		if (!gdt)
@@ -488,4 +496,6 @@ void pnpbios_calls_init(union pnp_bios_i
 		set_desc_base(&gdt[GDT_ENTRY_PNPBIOS_DS],
 			 (unsigned long)__va(header->fields.pm16dseg));
 	}
+
+	pax_close_kernel();
 }
diff -urNp linux-2.6.32.24/drivers/pnp/quirks.c linux-2.6.32.24/drivers/pnp/quirks.c
--- linux-2.6.32.24/drivers/pnp/quirks.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/pnp/quirks.c	2010-09-04 15:54:52.000000000 -0400
@@ -327,7 +327,7 @@ static struct pnp_fixup pnp_fixups[] = {
 	/* PnP resources that might overlap PCI BARs */
 	{"PNP0c01", quirk_system_pci_resources},
 	{"PNP0c02", quirk_system_pci_resources},
-	{""}
+	{"", NULL}
 };
 
 void pnp_fixup_device(struct pnp_dev *dev)
diff -urNp linux-2.6.32.24/drivers/pnp/resource.c linux-2.6.32.24/drivers/pnp/resource.c
--- linux-2.6.32.24/drivers/pnp/resource.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/pnp/resource.c	2010-09-04 15:54:52.000000000 -0400
@@ -355,7 +355,7 @@ int pnp_check_irq(struct pnp_dev *dev, s
 		return 1;
 
 	/* check if the resource is valid */
-	if (*irq < 0 || *irq > 15)
+	if (*irq > 15)
 		return 0;
 
 	/* check if the resource is reserved */
@@ -419,7 +419,7 @@ int pnp_check_dma(struct pnp_dev *dev, s
 		return 1;
 
 	/* check if the resource is valid */
-	if (*dma < 0 || *dma == 4 || *dma > 7)
+	if (*dma == 4 || *dma > 7)
 		return 0;
 
 	/* check if the resource is reserved */
diff -urNp linux-2.6.32.24/drivers/s390/cio/qdio_perf.c linux-2.6.32.24/drivers/s390/cio/qdio_perf.c
--- linux-2.6.32.24/drivers/s390/cio/qdio_perf.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/s390/cio/qdio_perf.c	2010-09-04 15:54:52.000000000 -0400
@@ -31,51 +31,51 @@ static struct proc_dir_entry *qdio_perf_
 static int qdio_perf_proc_show(struct seq_file *m, void *v)
 {
 	seq_printf(m, "Number of qdio interrupts\t\t\t: %li\n",
-		   (long)atomic_long_read(&perf_stats.qdio_int));
+		   (long)atomic_long_read_unchecked(&perf_stats.qdio_int));
 	seq_printf(m, "Number of PCI interrupts\t\t\t: %li\n",
-		   (long)atomic_long_read(&perf_stats.pci_int));
+		   (long)atomic_long_read_unchecked(&perf_stats.pci_int));
 	seq_printf(m, "Number of adapter interrupts\t\t\t: %li\n",
-		   (long)atomic_long_read(&perf_stats.thin_int));
+		   (long)atomic_long_read_unchecked(&perf_stats.thin_int));
 	seq_printf(m, "\n");
 	seq_printf(m, "Inbound tasklet runs\t\t\t\t: %li\n",
-		   (long)atomic_long_read(&perf_stats.tasklet_inbound));
+		   (long)atomic_long_read_unchecked(&perf_stats.tasklet_inbound));
 	seq_printf(m, "Outbound tasklet runs\t\t\t\t: %li\n",
-		   (long)atomic_long_read(&perf_stats.tasklet_outbound));
+		   (long)atomic_long_read_unchecked(&perf_stats.tasklet_outbound));
 	seq_printf(m, "Adapter interrupt tasklet runs/loops\t\t: %li/%li\n",
-		   (long)atomic_long_read(&perf_stats.tasklet_thinint),
-		   (long)atomic_long_read(&perf_stats.tasklet_thinint_loop));
+		   (long)atomic_long_read_unchecked(&perf_stats.tasklet_thinint),
+		   (long)atomic_long_read_unchecked(&perf_stats.tasklet_thinint_loop));
 	seq_printf(m, "Adapter interrupt inbound tasklet runs/loops\t: %li/%li\n",
-		   (long)atomic_long_read(&perf_stats.thinint_inbound),
-		   (long)atomic_long_read(&perf_stats.thinint_inbound_loop));
+		   (long)atomic_long_read_unchecked(&perf_stats.thinint_inbound),
+		   (long)atomic_long_read_unchecked(&perf_stats.thinint_inbound_loop));
 	seq_printf(m, "\n");
 	seq_printf(m, "Number of SIGA In issued\t\t\t: %li\n",
-		   (long)atomic_long_read(&perf_stats.siga_in));
+		   (long)atomic_long_read_unchecked(&perf_stats.siga_in));
 	seq_printf(m, "Number of SIGA Out issued\t\t\t: %li\n",
-		   (long)atomic_long_read(&perf_stats.siga_out));
+		   (long)atomic_long_read_unchecked(&perf_stats.siga_out));
 	seq_printf(m, "Number of SIGA Sync issued\t\t\t: %li\n",
-		   (long)atomic_long_read(&perf_stats.siga_sync));
+		   (long)atomic_long_read_unchecked(&perf_stats.siga_sync));
 	seq_printf(m, "\n");
 	seq_printf(m, "Number of inbound transfers\t\t\t: %li\n",
-		   (long)atomic_long_read(&perf_stats.inbound_handler));
+		   (long)atomic_long_read_unchecked(&perf_stats.inbound_handler));
 	seq_printf(m, "Number of outbound transfers\t\t\t: %li\n",
-		   (long)atomic_long_read(&perf_stats.outbound_handler));
+		   (long)atomic_long_read_unchecked(&perf_stats.outbound_handler));
 	seq_printf(m, "\n");
 	seq_printf(m, "Number of fast requeues (outg. SBAL w/o SIGA)\t: %li\n",
-		   (long)atomic_long_read(&perf_stats.fast_requeue));
+		   (long)atomic_long_read_unchecked(&perf_stats.fast_requeue));
 	seq_printf(m, "Number of outbound target full condition\t: %li\n",
-		   (long)atomic_long_read(&perf_stats.outbound_target_full));
+		   (long)atomic_long_read_unchecked(&perf_stats.outbound_target_full));
 	seq_printf(m, "Number of outbound tasklet mod_timer calls\t: %li\n",
-		   (long)atomic_long_read(&perf_stats.debug_tl_out_timer));
+		   (long)atomic_long_read_unchecked(&perf_stats.debug_tl_out_timer));
 	seq_printf(m, "Number of stop polling calls\t\t\t: %li\n",
-		   (long)atomic_long_read(&perf_stats.debug_stop_polling));
+		   (long)atomic_long_read_unchecked(&perf_stats.debug_stop_polling));
 	seq_printf(m, "AI inbound tasklet loops after stop polling\t: %li\n",
-		   (long)atomic_long_read(&perf_stats.thinint_inbound_loop2));
+		   (long)atomic_long_read_unchecked(&perf_stats.thinint_inbound_loop2));
 	seq_printf(m, "QEBSM EQBS total/incomplete\t\t\t: %li/%li\n",
-		   (long)atomic_long_read(&perf_stats.debug_eqbs_all),
-		   (long)atomic_long_read(&perf_stats.debug_eqbs_incomplete));
+		   (long)atomic_long_read_unchecked(&perf_stats.debug_eqbs_all),
+		   (long)atomic_long_read_unchecked(&perf_stats.debug_eqbs_incomplete));
 	seq_printf(m, "QEBSM SQBS total/incomplete\t\t\t: %li/%li\n",
-		   (long)atomic_long_read(&perf_stats.debug_sqbs_all),
-		   (long)atomic_long_read(&perf_stats.debug_sqbs_incomplete));
+		   (long)atomic_long_read_unchecked(&perf_stats.debug_sqbs_all),
+		   (long)atomic_long_read_unchecked(&perf_stats.debug_sqbs_incomplete));
 	seq_printf(m, "\n");
 	return 0;
 }
diff -urNp linux-2.6.32.24/drivers/s390/cio/qdio_perf.h linux-2.6.32.24/drivers/s390/cio/qdio_perf.h
--- linux-2.6.32.24/drivers/s390/cio/qdio_perf.h	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/s390/cio/qdio_perf.h	2010-09-04 15:54:52.000000000 -0400
@@ -13,46 +13,46 @@
 
 struct qdio_perf_stats {
 	/* interrupt handler calls */
-	atomic_long_t qdio_int;
-	atomic_long_t pci_int;
-	atomic_long_t thin_int;
+	atomic_long_unchecked_t qdio_int;
+	atomic_long_unchecked_t pci_int;
+	atomic_long_unchecked_t thin_int;
 
 	/* tasklet runs */
-	atomic_long_t tasklet_inbound;
-	atomic_long_t tasklet_outbound;
-	atomic_long_t tasklet_thinint;
-	atomic_long_t tasklet_thinint_loop;
-	atomic_long_t thinint_inbound;
-	atomic_long_t thinint_inbound_loop;
-	atomic_long_t thinint_inbound_loop2;
+	atomic_long_unchecked_t tasklet_inbound;
+	atomic_long_unchecked_t tasklet_outbound;
+	atomic_long_unchecked_t tasklet_thinint;
+	atomic_long_unchecked_t tasklet_thinint_loop;
+	atomic_long_unchecked_t thinint_inbound;
+	atomic_long_unchecked_t thinint_inbound_loop;
+	atomic_long_unchecked_t thinint_inbound_loop2;
 
 	/* signal adapter calls */
-	atomic_long_t siga_out;
-	atomic_long_t siga_in;
-	atomic_long_t siga_sync;
+	atomic_long_unchecked_t siga_out;
+	atomic_long_unchecked_t siga_in;
+	atomic_long_unchecked_t siga_sync;
 
 	/* misc */
-	atomic_long_t inbound_handler;
-	atomic_long_t outbound_handler;
-	atomic_long_t fast_requeue;
-	atomic_long_t outbound_target_full;
+	atomic_long_unchecked_t inbound_handler;
+	atomic_long_unchecked_t outbound_handler;
+	atomic_long_unchecked_t fast_requeue;
+	atomic_long_unchecked_t outbound_target_full;
 
 	/* for debugging */
-	atomic_long_t debug_tl_out_timer;
-	atomic_long_t debug_stop_polling;
-	atomic_long_t debug_eqbs_all;
-	atomic_long_t debug_eqbs_incomplete;
-	atomic_long_t debug_sqbs_all;
-	atomic_long_t debug_sqbs_incomplete;
+	atomic_long_unchecked_t debug_tl_out_timer;
+	atomic_long_unchecked_t debug_stop_polling;
+	atomic_long_unchecked_t debug_eqbs_all;
+	atomic_long_unchecked_t debug_eqbs_incomplete;
+	atomic_long_unchecked_t debug_sqbs_all;
+	atomic_long_unchecked_t debug_sqbs_incomplete;
 };
 
 extern struct qdio_perf_stats perf_stats;
 extern int qdio_performance_stats;
 
-static inline void qdio_perf_stat_inc(atomic_long_t *count)
+static inline void qdio_perf_stat_inc(atomic_long_unchecked_t *count)
 {
 	if (qdio_performance_stats)
-		atomic_long_inc(count);
+		atomic_long_inc_unchecked(count);
 }
 
 int qdio_setup_perf_stats(void);
diff -urNp linux-2.6.32.24/drivers/scsi/ipr.c linux-2.6.32.24/drivers/scsi/ipr.c
--- linux-2.6.32.24/drivers/scsi/ipr.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/scsi/ipr.c	2010-09-04 15:54:52.000000000 -0400
@@ -5286,7 +5286,7 @@ static bool ipr_qc_fill_rtf(struct ata_q
 	return true;
 }
 
-static struct ata_port_operations ipr_sata_ops = {
+static const struct ata_port_operations ipr_sata_ops = {
 	.phy_reset = ipr_ata_phy_reset,
 	.hardreset = ipr_sata_reset,
 	.post_internal_cmd = ipr_ata_post_internal,
